/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

//==========================================================
// ORIGINAL COPYRIGHT FOLLOWS
//==========================================================
// Yes::Engine - Free C++ 3D engine
//
// Copyright (C) 2004-2005 Laurent Gomila
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc.,
// 59 Temple Place - Suite 330,
// Boston, MA  02111-1307, USA.
//
// E-mail : laurent.gom@gmail.com
//==========================================================

//==========================================================
// En-têtes
//==========================================================
#include "KeosConsole.h"
#include "KeosException.h"

namespace Keos
{

////////////////////////////////////////////////////////////
/// Constructeur par défaut
///
////////////////////////////////////////////////////////////
CConsole::CConsole() :
m_Current(""),
m_Look   (NULL),
m_Enabled(false)
{
	RegisterCommand("?", Console::Bind(&CConsole::GetCommands, *this));
    RegisterCommand("help",   Console::Bind(&CConsole::HelpCommand, *this));
}


////////////////////////////////////////////////////////////
/// Change l'apparence de la console
///
/// \param NewLook : Pointeur sur le nouveau look
///
////////////////////////////////////////////////////////////
void CConsole::ChangeLook(Console::ILook* NewLook)
{
    Assert(NewLook != NULL);

    m_Look = NewLook;
}


////////////////////////////////////////////////////////////
/// Enregistre une nouvelle commande
///
/// \param Name :     Nom de la commande
/// \param Function : Foncteur contenant la fonction associée
///
////////////////////////////////////////////////////////////
void CConsole::RegisterCommand(const std::string& Name, const Console::CFunctor& Function,
                               const std::string& Help)
{
    m_Commands[Name] = Function;
    m_Helps[Name] = Help;
}


////////////////////////////////////////////////////////////
/// Envoie un nouveau caractère à la console
///
/// \param Character : Caractère
///
////////////////////////////////////////////////////////////
void CConsole::SendChar(char Character)
{
    // Si la console n'est pas active 
	// ou qu'il n'y pas de look défini 
	// on ne traite pas le caractère
    if (!m_Enabled || m_Look == NULL)
        return;

    // Traitement du caractère
    switch (Character)
    {
        // Saut de ligne : on traite la commande et on efface la ligne
        case '\n' :
        case '\r' :
            if (!m_Current.empty())
            {
                ProcessCurrent();
                m_Current.clear();
            }
            break;

        // Backspace : on efface le dernier caractère
        case '\b' :
            if (!m_Current.empty())
                m_Current.erase(m_Current.size() - 1);
            break;

        // Tout le reste : on ajoute le caractère à la ligne courante
        default :
            m_Current += Character;
            break;
    }

    // On notifie au "look" que le texte courant vient de changer
    m_Look->TextChanged(m_Current);
}


////////////////////////////////////////////////////////////
/// Met à jour la console
///
////////////////////////////////////////////////////////////
void CConsole::Update()
{
    m_Look->Update();
}


////////////////////////////////////////////////////////////
/// Affiche la console
///
////////////////////////////////////////////////////////////
void CConsole::Draw() const
{
    m_Look->Draw();
}


////////////////////////////////////////////////////////////
/// Active ou désactive la console
///
/// \param Enabled : Active / inactive
///
////////////////////////////////////////////////////////////
void CConsole::Enable(bool Enabled)
{
    m_Enabled = Enabled;
    if (m_Look != NULL) m_Look->Show(Enabled);
}


////////////////////////////////////////////////////////////
/// Donne la liste des commandes enregistrées
///
/// \return Chaîne contenant la liste des commandes enregistrées
///
////////////////////////////////////////////////////////////
std::string CConsole::GetCommands() const
{
    std::string List;
    for (TCommandTable::const_iterator i = m_Commands.begin(); i != m_Commands.end(); ++i)
        List += i->first + " ";

    return List;
}


////////////////////////////////////////////////////////////
/// Commande Help: permet d'avoir la description d'une commande
///
/// \param CommandName : Nom de la commande dont on veut la description
/// \return Description de la commande
///
////////////////////////////////////////////////////////////
String CConsole::HelpCommand(const String& CommandName)
{
    THelpTable::iterator It = m_Helps.find(CommandName);

    if (It != m_Helps.end())
        return m_Helps[CommandName];
	return CommandName + ": Unknown command!";
}


////////////////////////////////////////////////////////////
/// Traite la ligne courante et appelle la fonction correspondante
///
////////////////////////////////////////////////////////////
void CConsole::ProcessCurrent()
{
    // On récupère la commande
    std::string Command;
    std::istringstream iss(m_Current);
    iss >> Command;

    // On recherche la commande dans la table des commandes
    TCommandTable::iterator It = m_Commands.find(Command);

    // Si elle s'y trouve on appelle la fonction correspondante, sinon on génère une erreur
    if (It != m_Commands.end())
    {
        // Récupération des paramètres
        std::string Params;
        std::getline(iss, Params);

        // Appel du foncteur correspondant à la commande -
        // s'il y a une erreur on la rattrape et on l'affiche dans la console
        try
        {
            m_Look->CommandCalled(It->second(Params));
        }
        catch (CBadConversion&)
        {
            m_Look->Error("Invalid number (or type) of parameters !");
        }
        catch (std::exception& E)
        {
            m_Look->Error(E.what());
        }
    }
    else
    {
        m_Look->Error("Unknown command \"" + Command + "\"");
    }
}


} // namespace Keos
